;**********************************************************************
;                                                                     *
;    Filename:	    Exp03.asm                                        *
;    Date:          05/04/2002                                        *
;    File Version:                                                    *
;                                                                     *
;    Author: KRITSADA JAIYEN                                          *
;    Company: Innovative Experiment                                   *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Files required: p16f628.inc                                      *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Notes: Sound On Piezo                                            *
;                                                                     *
;**********************************************************************

	list      p=16f628            	; list directive to define processor
	#include <p16f628.inc>        	; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _XT_OSC & _MCLRE_ON & _LVP_OFF

	org	0x000
	clrf 	PORTA			; Initial PORTA by setting
					; output data latches 		
	movlw	0x07			; Turn Comparator off and
	movwf 	CMCON			; Enable pins for I/O
	bsf	STATUS,RP0		; Select Bank 1
	movlw	b'11101111'		; RA4 = Output
	movwf	PORTA			; Other = Input
	bcf	STATUS,RP0		; Return to Bank 0
Loop	bsf	PORTA,4			; High RA4 768 usec
	call	Delay
	bcf	PORTA,4			; Low RA4 768 usec
	call	Delay
	goto	Loop			; Frequency = 1/(768 usec + 768 usec) =  651 Hz

Delay	clrf	0x20			; Delay 768 usec  
	decfsz	0x20,f
	goto	$-1
	return

	END                

