;**********************************************************************
;                                                                     *
;    Filename:	    Exp04.asm                                        *
;    Date:          05/04/2002                                        *
;    File Version:                                                    *
;                                                                     *
;    Author: KRITSADA JAIYEN                                          *
;    Company: Innovative Experiment                                   *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Files required: p16f628.inc                                      *
;                                                                     *
;**********************************************************************
;           Mini Melody                                               *
;    Notes: Sound On Piezo From Key Switch                            *
;    Change Delay Time With Key Press                                 *
;                                                                     *
;**********************************************************************

	list      p=16f628            	; list directive to define processor
	#include <p16f628.inc>        	; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _XT_OSC & _MCLRE_ON & _LVP_OFF

COUNT	equ	0x20
TIME	equ	0x21

	org	0x000
	clrf 	PORTA			; Initial PORTA by setting
					; output data latches 		
	movlw	0x07			; Turn Comparator off and
	movwf 	CMCON			; Enable pins for I/O
	bsf	STATUS,RP0		; Select Bank 1
	movlw	0x0F			; RA0-RA3 =Input RA4 = Output 
	movwf	PORTA			; 
	bcf	STATUS,RP0		; Return to Bank 0
Loop	bsf	PORTA,4			; Start Rising Pulse
	call	Delay			; Delay 
	bcf	PORTA,4			; Falling Pulse
	call	Delay
	btfsc	PORTA,3			; Test RA3 Press
	goto	Check2			; If No Continue Check
	movlw	0x20			; If RA3 Press Set Time = 20H
	movwf	TIME
	goto	Loop			; Continue 
Check2	btfsc	PORTA,1			; Test RA1 Press
	goto	Check1			; If No Continue Check
	movlw	0x55			; If RA1 Press
	movwf	TIME			; Set Time = 55H
	goto	Loop			; Continue
Check1	btfsc	PORTA,0			; Test RA0 Press
	goto	Loop			; If No Begin Pulse Again
	movlw	0x60			; If RA0 Press
	movwf	TIME			; Set Time = 60H	
	goto	Loop			; Begin Pulse Again

Delay	movf	TIME,w			; Delay Use Change Delay Time
	movwf	COUNT			; With TIME Register
	decfsz	COUNT,f
	goto	$-1
	return



	END          	          	; directive 'end of program'

