;**********************************************************************
;    Filename:	Exp05.asm                                            *
;    Date:      05/04/2002                                            *
;    Author: 	KRITSADA JAIYEN                                       *
;    Company: Innovative Experiment                                   *
;**********************************************************************
;    Files required: p16f628.inc                                      *
;**********************************************************************
;    Notes: Stepper Motor Drive 360 degree                            *
;    Use ER For External Resiter and No Clock Out                     *
;**********************************************************************

	list      p=16f628            	; list directive to define processor
	#include <p16f628.inc>        	; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _ER_OSC_NOCLKOUT & _MCLRE_ON & _LVP_OFF

COUNT	equ	0x20
DUMMY1	equ	0x21
DUMMY2	equ	0x22

	org	0x000			; Reset Vetor Address
	bsf	STATUS,RP0		; Set RB4-RB7 For Drive Stepper Motor
	movlw	b'00001111'
	movwf	PORTB
	bcf	STATUS,RP0

Begin	movlw	.12			; Loop 12 Time For 7.5 Degree/Step 4x12x7.5 = 360
	movwf	COUNT
Loop	movlw	b'00010000'		; 1 Phase Full Step
	movwf	PORTB
	call	Delay			; Change Delay For Change Speed	
	movlw	b'00100000'
	movwf	PORTB
	call	Delay
	movlw	b'01000000'
	movwf	PORTB
	call	Delay
	movlw	b'10000000'
	movwf	PORTB
	call	Delay
	decfsz	COUNT,f			; Check Loop = 12 Time ?
	goto	Loop			; If Not Loop Again

	movlw	.12			; Reverse Move 12 Time
	movwf	COUNT
Loop2	movlw	b'01000000'
	movwf	PORTB
	call	Delay
	movlw	b'00100000'
	movwf	PORTB
	call	Delay
	movlw	b'00010000'
	movwf	PORTB
	call	Delay
	movlw	b'10000000'
	movwf	PORTB
	call	Delay
	decfsz	COUNT,f			; Check Loop = Time ?	
	goto	Loop2
	goto	Begin			; If Yes Start Again

Delay	movlw	0x20			; Delay Between Step 
	movwf	DUMMY1
Delay1	clrf	DUMMY2
	decfsz	DUMMY2,f
	goto	$-1
	decfsz	DUMMY1,f
	goto	Delay1
	return

		END                    	; directive 'end of program'

