;**********************************************************************
;                                                                     *
;    Filename:	    Exp06.asm                                        *
;    Date:          05/04/2002                                        *
;    File Version:                                                    *
;                                                                     *
;    Author: KRITSADA JAIYEN                                          *
;    Company: Innovative Experiment                                   *
;                                                                     *
;**********************************************************************
;    Files required: p16f628.inc                                      *
;**********************************************************************
;    Notes: Send Data To Shift Register                               *
;**********************************************************************

	list      p=16f628            	; list directive to define processor
	#include <p16f628.inc>        	; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _XT_OSC & _MCLRE_ON & _LVP_OFF
SEND	equ	0x20
COUNT	equ	0x21

#define	DAT_PIN	PORTB,0			; 74595 DATA PIN
#define LATCH	PORTB,4			; 74595 LATCH PIN 
#define CLK	PORTB,5			; 74595 CLK PIN
			
	org	0x000
Init	bsf	STATUS,RP0		; Bank 1
	movlw	b'10000110'		; Use RB0,RB3-RB6
	movwf	PORTB			; For Output
	bcf	STATUS,RP0		; Bank 0
	bcf	LATCH			; Falling Edge Latch	
	bcf	CLK			; Falling Edge Clock	
Main	movlw	0x0A			; On LED with 0AH value 
	call	Send_Dat			; Send Data Subroutine
	goto	$

Send_Dat movwf	SEND			; Load Data
	movlw	0x08			; Loop 8 Time : Send 8 Data Bit
	movwf	COUNT
Chk_Bit	bcf	DAT_PIN			; RB0 >> DATA PIN
	btfsc	SEND,7			; Check bit 7 0 Or 1	
	bsf	DAT_PIN			; Send Bit 7 To Shift Register
Clock	bsf	CLK			; Clock Pulse
	bcf	CLK		
Rotate	rlf	SEND,f			; Rotate Bit For Send Other Bit
	decfsz	COUNT,f			; Test Loop 8 Time ?
	goto	Chk_Bit			; If No Send Bit Again
Latch	bsf	LATCH			; Latch Data For Show Long Time
	bcf	LATCH
	return
	
	END                    	; directive 'end of program'

