;**********************************************************************
;    Filename:	    Exp07.asm                                        *
;    Date:          05/04/2002                                        *
;    Author: KRITSADA JAIYEN                                          *
;    Company: Innovative Experiment                                   *
;**********************************************************************
;    Files required: p16f628.inc                                      *
;**********************************************************************
;    Notes: Running LED                            		      *	
;**********************************************************************

	list      p=16f628            	; list directive to define processor
	#include <p16f628.inc>        	; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _XT_OSC & _MCLRE_ON & _LVP_OFF

SEND	equ	0x20
COUNT	equ	0x21
ROT	equ	0x22
DUMMY1	equ	0x23
DUMMY2	equ	0x24
	
#define	DAT_PIN	PORTB,0			; 74595 DATA PIN
#define LATCH	PORTB,4			; 74595 LATCH PIN 
#define CLK	PORTB,5			; 74595 CLK PIN

Init	bsf	STATUS,RP0		; Bank 1	
	movlw	b'10001110'		; Use RB0,RB4,RB5,RB6
	movwf	PORTB
	bcf	STATUS,RP0		; Bank 0

	movlw	0x01			; Load data
	movwf	ROT			; For one LED on
	movf	ROT,w			; Send data to shift register
	call	Send_Dat
	call	Delay			; Delay for LED running speed
Left	bcf	STATUS,C		; Clear Carry flag
	rlf	ROT,f			; Rotate LED <<< left
	movf	ROT,w			; Send data to shift register
	call	Send_Dat
	call	Delay			; Delay for LED running speed
	btfss	ROT,7			; Test bit 7 set ?
	goto	Left			; If no, rotate again
Right	bcf	STATUS,C		; If yes, LED goto MSB bit
	rrf	ROT,f			; Rotate LED >>> right
	movf	ROT,w			; Send data to shift register
	call	Send_Dat
	call	Delay			; Delay for LED running speed
	btfsc	ROT,0			; Test Bit 0 set
	goto	Left			; If yes, LED goto LSB bit
	goto	Right			; If no, rotate again

Delay	clrf	DUMMY1			; Delay subroutine
Delay1	clrf	DUMMY2
	decfsz	DUMMY2,f
	goto	$-1
	decfsz	DUMMY1,f
	goto	Delay1
	return	
	
Send_Dat movwf	SEND			; Load data
	movlw	0x08			; Loop 8 times for sending 8-bit data
	movwf	COUNT
Chk_Bit	bcf	DAT_PIN			; RB0 >> DATA pin of 74HC595
	btfsc	SEND,7			; Check bit 7 0 or 1	?
	bsf	DAT_PIN			; Send bit 7 to shift register
Clock	bsf	CLK			; Clock pulse
	bcf	CLK		
Rotate	rlf	SEND,f			; Rotate bit for sending next bit
	decfsz	COUNT,f			; Test loop 8 times ?
	goto	Chk_Bit			; If no, send bit again
Latch	bsf	LATCH			; Latch data for showing
	bcf	LATCH
	return

	END   	                 	

