;**********************************************************************
;    Filename:	    Exp08.asm                                        *
;    Date:          05/04/2002                                        *
;    Author: KRITSADA JAIYEN                                          *
;    Company: Innovative Experiment                                   *
;**********************************************************************
;    Files required: p16f628.inc                                      *
;**********************************************************************
;    Notes: Decode 7 Segment and Count Down 9 To 0                    *
;**********************************************************************

	list      p=16f628            	; list directive to define processor
	#include <p16f628.inc>        	; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _XT_OSC & _MCLRE_ON & _LVP_OFF

SEND	equ	0x20
COUNT	equ	0x21
DAT	equ	0x22	
DUMMY1	equ	0x23
DUMMY2	equ	0x24

#define	DAT_PIN	PORTB,0			; 74595 DATA PIN
#define LATCH	PORTB,4			; 74595 LATCH PIN 
#define CLK	PORTB,5			; 74595 CLK PIN
#Define DSP1	PORTB,6			; 7 Segment digit 1
	
	org	0x000			; Start address
	goto	Init	

Table_	addwf	PCL,f			; Table for LED 7 segment
	retlw	0x3f			; 0
	retlw	0x06			; 1
	retlw	0x5b			; 2
	retlw	0x4f			; 3
	retlw	0x66			; 4
	retlw	0x6d			; 5	
	retlw	0x7d			; 6
	retlw	0x07			; 7
	retlw	0x7f			; 8
	retlw	0x6f			; 9
	return	

Init	bsf	STATUS,RP0		; RB0, RB4-RB6 = Output
	bcf 	DAT_PIN			; DATA to 74595 > output
	bcf	LATCH			; LATCH to 74595 > output  
	bcf 	CLK			; Clock  to 74595 > output  
	bcf 	DSP1			; Common for digit 1 > output
	bcf	STATUS,RP0
	bcf	DSP1

Loop	movlw	0x09			; Show the first data with 9
	movwf	DAT
Main	movf	DAT,w			; Load data for converting from table
	call	Table_			; Convert data
	call	Send_Dat			; Send data to LED 7 segment
	call	Delay			; Delay for showing display
	decfsz	DAT,f			; Decrement data and test = 0 ?
	goto	Main			; If no, repeat 
	movf	DAT,w			; If = 0, show number 0 
	call	Table_
	call	Send_Dat
	call	Delay			; 
	goto	Loop			; Back to begin

Send_Dat movwf	SEND			; Load data
	movlw	0x08			; Loop 8 times for sending 8-bit data
	movwf	COUNT
Chk_Bit	bcf	DAT_PIN			; RB0 >> DATA pin
	btfsc	SEND,7			; Check bit 7 "0" or "1"	
	bsf	DAT_PIN			; Send bit 7 to shift register
Clock	bsf	CLK			; Clock pulse
	bcf	CLK		
Rotate	rlf	SEND,f			; Rotate bit for sending next bit
	decfsz	COUNT,f			; Test loop 8 times ?
	goto	Chk_Bit			; If no, send bit again
Latch	bsf	LATCH			; Latch data for showing
	bcf	LATCH
	return

Delay	clrf	DUMMY1			; Delay 263 millisecond
Delay1	clrf	DUMMY2
	nop				; Use for incrementing delay time
	decfsz	DUMMY2,f
	goto	$-2
	decfsz	DUMMY1,f
	goto	Delay1
	return			
	

		END                    	

