;**********************************************************************
;                                                                     *
;    Filename:	    Exp09.asm                                        *
;    Date:          06/04/2002                                        *
;    Author: KRITSADA JAIYEN                                          *
;    Company: Innovative Experiment                                   *
;**********************************************************************
;    Files required: p16f628.inc                                      *
;**********************************************************************
;    Notes: 2 Digit 7 Segment                                         *
;**********************************************************************

	list      p=16f628            	; list directive to define processor
	#include <p16f628.inc>        	; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _XT_OSC & _MCLRE_ON & _LVP_OFF

SEND	equ	0x20
COUNT	equ	0x21
DAT	equ	0x22	
DUMMY3	equ	0x25

#define	DAT_PIN	PORTB,0			; 74595 DATA pin
#define LATCH	PORTB,4			; 74595 LATCH pin 
#define CLK	PORTB,5			; 74595 CLK pin
#Define	DSP1	PORTB,6			; Common Of LED 7 Segment - digit 1 on the right hand
#Define DSP2	PORTB,7			; Common of LED 7 Segment - digit 2 on the left hand
	
	org	0x000
	goto	Init
	
Table_	addwf	PCL,f			; Table for LED 7 segment
	retlw	0x3f			; 0
	retlw	0x06			; 1
	retlw	0x5b			; 2
	retlw	0x4f			; 3
	retlw	0x66			; 4
	retlw	0x6d			; 5	
	retlw	0x7d			; 6
	retlw	0x07			; 7
	retlw	0x7f			; 8
	retlw	0x6f			; 9
	return	

Init	bsf	STATUS,RP0
	movlw	b'00001110'		; RB0, RB4-RB7 = output
	movwf	PORTB
	bcf	STATUS,RP0

	bsf	DSP1			; Digit 1 off
	bsf	DSP2			; Digit 2 off

Loop	movlw	0x02			; Load right display with "2"
	call	Table_			; Get LED data from table
	call	Send_Dat			; Send data to 74HC595
	bcf	DSP1			; ON DSP1 LED	
	call	Delay2			; Short delay for showing
	bsf	DSP1			; Off DSP1 LED

	movlw	0x08			; Load left display with "8"
	call	Table_			; Get LED data from table
	call	Send_Dat			; Send data to 74HC595
	bcf	DSP2			; ON DSP2 LED	
	call	Delay2			; Short delay for showing
	bsf	DSP2			; Off DSP2 LED
	goto	Loop			; Show again

Send_Dat movwf	SEND			; Load data
	movlw	0x08			; Loop 8 times for sending 8-bit  data
	movwf	COUNT
Chk_Bit	bcf	DAT_PIN			; RB0 >> DATA pin
	btfsc	SEND,7			; Check bit 7 "0" or "1"	
	bsf	DAT_PIN			; Send Bit 7 to shift register
Clock	bsf	CLK			; Clock pulse
	bcf	CLK		
Rotate	rlf	SEND,f			; Rotate bit for sending next bit
	decfsz	COUNT,f			; Test loop 8 times ?
	goto	Chk_Bit			; If no, send bit again
Latch	bsf	LATCH			; Latch data for showing 
	bcf	LATCH
	return

Delay2	clrf	DUMMY3			; Short delay for multiplexing 
	decfsz	DUMMY3,f
	goto	$-1	
	return

	END                    		

