;**********************************************************************
;    Filename:	    Exp10.asm                                        *
;    Date:          06/04/2002                                        *
;    Author: KRITSADA JAIYEN                                          *
;    Company: Innovative Experiment                                   *
;**********************************************************************
;    Files required: p16f628.inc                                      *
;**********************************************************************
;    Notes: 2 Digit 7 Segment Up Counter  and ON Relay                *
;**********************************************************************

	list      p=16f628      ; list directive to define processor
	#include <p16f628.inc>  ; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _XT_OSC & _MCLRE_ON & _LVP_OFF

	CBLOCK	0x20
SEND	
COUNT	
DAT	
DUMMY1	
DUMMY2	
DIGIT1	
DIGIT2	
	ENDC

#define	DAT_PIN	PORTB,0		; 74595 DATA pin
#define LATCH	PORTB,4		; 74595 LATCH  pin
#define CLK	PORTB,5		; 74595 CLK pin
#Define	DSP1	PORTB,6		; Common Of LED 7 Segment - digit 1 on the right hand
#Define DSP2	PORTB,7		; Common of LED 7 Segment - digit 2 on the left hand
	
	
	org	0x000
	goto	Init
	
Table_	addwf	PCL,f		; Table for LED 7 segment
	retlw	0x3f		; 0
	retlw	0x06		; 1
	retlw	0x5b		; 2
	retlw	0x4f		; 3
	retlw	0x66		; 4
	retlw	0x6d		; 5	
	retlw	0x7d		; 6
	retlw	0x07		; 7
	retlw	0x7f		; 8
	retlw	0x6f		; 9
	return		

Init	movlw	0x07		; PORTA as digital I/O
	movwf	CMCON	
	bsf	STATUS,RP0
	movlw	b'00001110'	; RB0, RB4-RB7 as output
	movwf	PORTB
	bcf	PORTA,4		; RA4 asa output for driving relay
	bcf	STATUS,RP0

	bsf	PORTA,4		; Relay off
	bsf	DSP1		; DSP1 off
	bsf	DSP2		; DSP2 off

	clrf	DIGIT1		; Start with 00
	clrf	DIGIT2
Loop	call	Delay			
	movlw	0x09		; Test DSP1 = 9 ?
	subwf	DIGIT1,w	
	btfsc	STATUS,Z
	goto	Inc2		; If yes, increase DSP2
	incf	DIGIT1,f		; If no, increase DSP1
	goto	Loop		;

Inc2	clrf	DIGIT1		; DSP1 back to "0"
	movlw	0x09		; Test DSP2 = 9 ?
	subwf	DIGIT2,w		
	btfsc	STATUS,Z
	goto	Clear		; If DSP2 = 9, clear all display
	incf	DIGIT2,f		; If no, increase DSP2
	goto	Loop		; 

Clear	bcf	PORTA,4		; Relay on
	clrf	DIGIT1		; DSP1 goto "0"
	clrf	DIGIT2		; DSP2 goto "0"
	call	Delay		; Display continue.. 
	goto	$-1		; Halt

Disp	movf	DIGIT1,w		; Load DSP1 
	call	Table_		; Get LED data from table 
	call	Send_Dat		; Send data to 74HC595
	bcf	DSP1		; ON DSP1
	call	Delay2		; 
	bsf	DSP1		; Off DSP1

	movf	DIGIT2,w		; Load DSP2 
	call	Table_		; Get LED data from table 
	call	Send_Dat		; Send data to 74HC595
	bcf	DSP2		; ON DSP2
	call	Delay2		; 
	bsf	DSP2		; Off DSP2
	return	

Send_Dat movwf	SEND		; Load data
	movlw	0x08		; Loop 8 times for sending 8-bit data
	movwf	COUNT
Chk_Bit	bcf	DAT_PIN		; RB0 >> DATA pin
	btfsc	SEND,7		; Check bit 7 "0" or "1"	
	bsf	DAT_PIN		; Send bit 7 to shift register
Clock	bsf	CLK		; Clock pulse
	bcf	CLK		
Rotate	rlf	SEND,f		; Rotate bit for sending next bit
	decfsz	COUNT,f		; Test loop 8 times ?
	goto	Chk_Bit		; If no, send bit again
Latch	bsf	LATCH		; Latch data for showing display
	bcf	LATCH
	return

Delay	clrf	DUMMY1		; Show data on LED 7 segment display 
Delay1	call	Disp
	decfsz	DUMMY1,f
	goto	Delay1
	return			

Delay2	clrf	DUMMY2		; Multiplexing delay
	decfsz	DUMMY2,f
	goto	$-1	
	return
		
	END                    

