;**********************************************************************
;                                                                     *
;    Filename:	    Exp11.asm                                        *
;    Date:          06/04/2002                                        *
;    Author: KRITSADA JAIYEN                                          *
;    Company: Innovative Experiment                                   *
;**********************************************************************
;    Files required: p16f628.inc                                      *
;**********************************************************************
;    Notes: 1 Hz From Timer0			                      *
;**********************************************************************

	list      p=16f628     	; list directive to define processor
	#include <p16f628.inc>  ; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _XT_OSC & _MCLRE_ON & _LVP_OFF

	CBLOCK	0x20
SEND	
COUNT	
SECOND	
FLAG_	
	ENDC

#define	DAT_PIN	PORTB,0		; 74595 DATA pin
#define LATCH	PORTB,4		; 74595 LATCH pin
#define CLK	PORTB,5		; 74595 CLK pin
#Define DSP1	PORTB,6		; DSP1 Common

	org	0x000		
	goto	Init

	org	0x004		; Interrupt vector
	goto	ISR

ISR	nop			; Accuracy delay
	bcf	INTCON,T0IF	; Clear Timer0 interrupt flag
	movlw	0x07		; Load 250 times for timer
	movwf	TMR0
	incfsz	SECOND,f	; Increase 0.5 second counter register 	
	goto	Ret2		; If <> 0, return	
	movlw	0x80		; If = 0, toggle LED
	xorwf	FLAG_,f
	movlw	0x06		; Load 250 times again
	movwf	SECOND
Ret2	retfie 			; Return from interrupt

Init	bsf	STATUS,RP0	;
	movlw	b'10001110'	; RB0, RB4-RB6 as output
	movwf	PORTB
	movlw	b'11000010'	; Use Timer0 and set prescaler 1:8
	movwf	OPTION_REG	
	bcf	STATUS,RP0

	clrf	FLAG_		; Clear register

	bcf	INTCON,T0IF	; Clear Timer0 interrupt flag
	bsf	INTCON,T0IE	; Enable Timer0 interrupt 
	bsf	INTCON,GIE	; Enable global interrupt

	movlw	0x07		; Load 249 times to TMR0
	movwf	TMR0
	movlw	0x06		; Load 250 times  to TMR0
	movwf	SECOND

	bcf	DSP1		; ON DSP1
Loop	movf	FLAG_,w		; Read flag from interrupt
	call	Send_Dat		; Send data to dot-point LED of DSP1 	
	goto	Loop

;**********************************************************************
;                     SubRoutine 				      *	
;**********************************************************************
Send_Dat movwf	SEND		; Load data
	movlw	0x08		; Loop 8 times for sending 8-bit data
	movwf	COUNT
Chk_Bit	bcf	DAT_PIN		; RB0 as DATA pin 
	btfsc	SEND,7		; Check bit 7 "0" or "1"	
	bsf	DAT_PIN		; Send Bit 7 to shift register
Clock	bsf	CLK		; Clock pulse
	bcf	CLK		
Rotate	rlf	SEND,f		; Rotate bit for sending next bit
	decfsz	COUNT,f		; Test loop 8 times ?
	goto	Chk_Bit		; If no, send bit again
Latch	bsf	LATCH		; Latch data for showing display
	bcf	LATCH
	return


	END                    	
