;**********************************************************************
;    Filename:	    Exp16.asm                                        *
;    Date:          11/04/2002                                        *
;    Author: KRITSADA JAIYEN                                          *
;    Company: Innovative Experiment                                   *
;**********************************************************************
;    Files required: p16f628.inc                                      *
;**********************************************************************
;    Notes: Transmit Data To Computer Via  RS-232 Port                *
;**********************************************************************
	list      p=16f628      ; list directive to define processor
	#include <p16f628.inc>  ; processor specific variable definitions
	errorlevel 0,-302
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _XT_OSC & _MCLRE_ON & _LVP_OFF

COUNT	equ	0x20

	org	0x000
	goto	Start

Table_	addwf	PCL,f		; Data table 
	dt	"Data From PIC16F628 "

Start	call	Initial		; Set baud rate and enable data transmitting
	clrf	COUNT		; 
Loop	call	Test_Empty	; Check buffer empty
	movf	COUNT,w		; Use COUNT for convertion data table
	call	Table_		; Get data from table
	movwf	TXREG		; Send to TXREG register
	incf	COUNT,f		; Increment counter
	movlw	.20		; Test counter = 20 times
	subwf	COUNT,w
	btfss	STATUS,Z	
	goto	Loop		; If <> 20, loop again
	goto	$		; If = 20,  stop program here

;**********************************************************************
;    	Subroutine					              *
;**********************************************************************
Test_Empty			; Test transmitter buffer empty
	bsf	STATUS,RP0
	btfss	TXSTA,TRMT	; If not empty, loop again
	goto	$-1
	bcf	STATUS,RP0
	return				

Initial	bsf	STATUS,RP0	; Initial port first
	movlw	.25
	movwf	SPBRG		; Set 9600 buad rate
	bcf	TXSTA,SYNC	; Set asynchonous Mode
	bsf	TXSTA,BRGH	; Set high speed baudrate
	bsf	TXSTA,TXEN	; Enable data transmittion
	bcf	STATUS,RP0
	bsf	RCSTA,SPEN	; Enable serial port
	return

	END                    	; Directive 'end of program'

