;**********************************************************************
;    Filename:	    Exp20.asm                                         *
;    Date:          19/04/2002                                        *
;    Author: KRITSADA JAIYEN                                          *
;    Company: Innovative Experiment                                   *
;**********************************************************************
;    Files required: p16f628.inc                                      *
;**********************************************************************
;    Notes: Simple A/D converter 		      *
;**********************************************************************

	list      p=16f628            	; list directive to define processor
	#include <p16f628.inc>        	; processor specific variable definitions
	errorlevel 0,-302
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _XT_OSC & _MCLRE_ON & _LVP_OFF

COUNT	equ	0x20
SEND 	equ	0x21
TEMP	equ	0x70		; Access All Bank File Register

#define	DAT_PIN	PORTB,0		; 74595 DATA pin
#define LATCH	PORTB,4		; 74595 LATCH pin 
#define CLK	PORTB,5		; 74595 CLK pin

	org	0x000
	movlw	b'00000010'	; Set Vref mode to Vin+ and RA1 to Vin-
	movwf	CMCON
	bsf	STATUS,RP0
	movlw	b'10001110'	; Set output port for displaying on LED
	movwf	PORTB
	movlw	b'10100000'	; Vref disconnect from RA2, set to low Range, Vref power ON
	movwf	VRCON		; 
	bcf	STATUS,RP0
	clrf	TEMP		; Start with 0V

Loop	btfsc	CMCON,C2OUT	; Vref > Voltage at RA1 ?
	goto	Show		; If > then show data on LED
	call	Inc		; If < increment Vref
	goto	Loop		; Test again

Show	movf	TEMP,w		; Show data from TEMP register
	call	Send_Dat		
	clrf	TEMP		; Check again
	call	Again		; For changing data	
	goto	Loop

;**********************************************************************
;    	Subroutine						      *
;**********************************************************************
Inc	incf	TEMP,w		; Increment TEMP 
	andlw	0x0f		; Use 4-bit LSB
	movwf	TEMP		; Backup again		
Again	bsf	STATUS,RP0	; Use TEMP register all bank
	movlw	0xf0		; Maintain 4-bit MSB of VRCON
	andwf	VRCON,w		; Clear 4-bit LSB of VRCON
	addwf	TEMP,w		; Add VRCON with TEMP
	movwf	VRCON		; Send back to VRCON
	bcf	STATUS,RP0
	return

Send_Dat movwf	SEND		; Load data
	movlw	0x08		; Loop 8 times for sending 8-bit data
	movwf	COUNT
Chk_Bit	bcf	DAT_PIN		; 
	btfsc	SEND,7		; Check bit 7 "0" or "1"	
	bsf	DAT_PIN		; Send bit 7 to shift register
Clock	bsf	CLK		; Clock pulse
	bcf	CLK		
Rotate	rlf	SEND,f		; Rotate bit for sending next bit
	decfsz	COUNT,f		; Test loop 8 times ?
	goto	Chk_Bit		; If no, send bit again
Latch	bsf	LATCH		; Latch data for displaying
	bcf	LATCH
	return
	
	end
