;**********************************************************************
;    Filename:	    Exp25.asm                                         *
;    Date:          24/04/2002                                        *
;    Author: KRITSADA JAIYEN                                          *
;    Company: Innovative Experiment                                   *
;**********************************************************************
;    Files required: p16f628.inc                                      *
;**********************************************************************
;    Notes: Show Pulse Width Modulation Frequency ~ 980 Hz            *
;           Duty Cycle 50%    8 Bit Mode                              *
;    Voltage On RB3 Pin ~ 2.5 Volt = 1/2*VCC                          *
;**********************************************************************

	list      p=16f628      ; list directive to define processor
	#include <p16f628.inc>  ; processor specific variable definitions
	errorlevel 0,-302	; Disables Bank Warnning
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _XT_OSC & _MCLRE_ON & _LVP_OFF

	org	0x000		; Reset address
Start	bsf	STATUS,RP0
	movlw	b'11110111'	; RB3 as output
	movwf	PORTB
	bcf	STATUS,RP0
	bcf	PORTB,3		; Clear RB3
	clrf	CCP1CON	; Set Capture/Compare/PWM Off
	bsf	STATUS,RP0
	movlw	0xff		; Period time = 256
	movwf	PR2
	bcf	STATUS,RP0	; Frequency is approximate 980 Hz
	bcf	CCP1CON,4	; Select 8-Bit mode, clear LSB bit 
	bcf	CCP1CON,5
	movlw	0x7f		; Duty Cycle = 50%
	movwf	CCPR1L
	movlw	0x01
	movwf	T2CON		; Prescaler = 1:4 and Timer2 Off
	clrf	TMR2
	movlw	b'00001100'
	movwf	CCP1CON	; Set PWM Mode
	bsf	T2CON,2		; Start Timer2
	goto	$ 

	end
