;**********************************************************************
;    Filename:	    Exp28.asm                                         *
;    Date:          27/04/2002                                        *
;    Author: KRITSADA JAIYEN                                          *
;    Company: Innovative Experiment                                   *
;**********************************************************************
;    Files required: p16f628.inc                                      *
;**********************************************************************
;    Notes: Use Timer1 With Compare Mode 			      *	
;	Generate Pulse = 500 millisecond               		      *
;           Use instruction clock prescale 1:8 			      *	
;	    Count 16 Bit 0- 62500 		                      *                             *
;**********************************************************************

	list      p=16f628      ; list directive to define processor
	#include <p16f628.inc>  ; processor specific variable definitions
	errorlevel 0,-302	; Disables Bank Warnning
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _XT_OSC & _MCLRE_ON & _LVP_OFF

	org	0x000		; Reset address
	goto	Start

	org	0x004		; Interrupt vector address
	goto	ISR

Start	clrf	PORTA
	movlw	0x07		; Set PORTA to digital I/O
	movwf	CMCON
	bsf	STATUS,RP0
	movlw	b'11111110'	; RA0 as output for displaying on LED
	movwf	PORTA
	bcf	STATUS,RP0
	movlw	b'00110000'	; Prescaler 1:8, stop Timer1
	movwf	T1CON
	bcf	PIR1,CCP1IF	; Clear Compare interrupt flag
	clrf	TMR1H		; Clear counter high
	clrf	TMR1L		; Clear counter low
	movlw	0xf4		; Load compare with 62500 
	movwf	CCPR1H		; 
	movlw	0x24
	movwf	CCPR1L
	bsf	INTCON,GIE	; Enable global interrupt 	
	bsf	INTCON,PEIE	; Enable peripheral interrupt
	bsf	STATUS,RP0	
	bsf	PIE1,CCP1IE	; Enable compare interrupt
	bcf	STATUS,RP0	
	movlw	b'00001010'	; Use software interrupt Only not set CCP1 pin
	movwf	CCP1CON
	bsf	T1CON,TMR1ON	; Start Timer1
	goto	$
;**********************************************************************
;    	Interrupt Service Routine                                     *
;**********************************************************************
ISR	clrf	TMR1L
	clrf	TMR1H
	bcf	PIR1,CCP1IF	; Clear Compare interrupt flag
	movlw	0x01
	xorwf	PORTA,f		; Toggle RA0
	retfie			; Return from interrupt
					

	end
